/****************************************************************************
**
** Copyright (C) 2014 Hevele Hegyi Istvan.
**
** This file is part of the fairySQL project.
**
** Copyright (C) 2013 Digia Plc and/or its subsidiary(-ies).
** Contact: http://www.qt-project.org/legal
**
** $QT_BEGIN_LICENSE:BSD$
** You may use this file under the terms of the BSD license as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of Digia Plc and its Subsidiary(-ies) nor the names
**     of its contributors may be used to endorse or promote products derived
**     from this software without specific prior written permission.
**
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
**
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef HIGHLIGHTER_H
#define HIGHLIGHTER_H
#include <QSyntaxHighlighter>

#include <QTextCharFormat>

class QTextDocument;

//QFairyHighlighter

class QFairyHighlighter : public QSyntaxHighlighter
{
    Q_OBJECT

public:
    QFairyHighlighter(QTextDocument *parent = 0);
protected:
    void highlightBlock(const QString &text);

private:
    struct HighlightingRule
    {
        QRegExp pattern;
        QTextCharFormat format;
    };

    QVector<HighlightingRule> highlightingRules;

    QRegExp commentStartExpression;
    QRegExp commentEndExpression;
    QRegExp braceStart; QRegExp braceEnd;

    QTextCharFormat keywordFormat;
    QTextCharFormat classFormat;
    QTextCharFormat singleLineCommentFormat;
    QTextCharFormat multiLineCommentFormat;
    QTextCharFormat braceFormat;
    QTextCharFormat quotationFormat;
    QTextCharFormat singleQuotationFormat;
    QTextCharFormat functionFormat;
    QTextCharFormat braceFormater;
    QTextCharFormat numberFormat;
    QTextCharFormat showFieldFormat;
    QTextCharFormat htmlNumberFormat;
    QTextCharFormat dollarNumberFormat;
    QTextCharFormat stringFormat;
};
#endif //HIGHLIGHTER_H
/*

#ifndef HIGHLIGHTER_H
#define HIGHLIGHTER_H

#include <QSyntaxHighlighter>
#include <QRegExp>

class SQLSyntaxHighlighter : public QSyntaxHighlighter
{
public:
    SQLSyntaxHighlighter (QTextEdit *te) : QSyntaxHighlighter (te) {}

    virtual void highlightBlock (const QString& text)
    {
    int pos = 0;

    static QRegExp rgx ("^\\s*(--)");

    if ((pos = rgx.search (text, pos)) != -1)
    {
        setFormat (pos, text.length(), Qt::green);
        return;
    }

    setFormat (0, text.length(), Qt::black);

    static QRegExp rw_rgx ("\\b(?:select|from|where|and|case|when|then|else|distinct|all|null|"
            "is|like|between|not|count|group|by|having|order|inner|outer|right|left|"
            "join|on|using|union|exists|in|as|intersect|except|coalesce|insert|delete|into|update)\\b", false);

    pos = 0;
    while ((pos = rw_rgx.search (text, pos)) != -1)
    {
        setFormat (pos, rw_rgx.matchedLength(), Qt::blue);
        pos += rw_rgx.matchedLength();
    }

    static QRegExp o_rgx (":(\\w*)");

    pos = 0;
    while ((pos = o_rgx.search (text, pos)) != -1)
    {
        setFormat (pos, o_rgx.matchedLength(), Qt::red);
        pos += o_rgx.matchedLength();
    }
    }
};
#endif //HIGHLIGHTER_H
*/
