/****************************************************************************
**
** Copyright (C) 2014 Hevele Hegyi Istvan.
**
** This file is part of the fairySQL project.
**
** Copyright (C) 2013 Digia Plc and/or its subsidiary(-ies).
** Contact: http://www.qt-project.org/legal
**
** $QT_BEGIN_LICENSE:BSD$
** You may use this file under the terms of the BSD license as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of Digia Plc and its Subsidiary(-ies) nor the names
**     of its contributors may be used to endorse or promote products derived
**     from this software without specific prior written permission.
**
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
**
** $QT_END_LICENSE$
**
****************************************************************************/

#include <QApplication>
#include <QSettings>

#include "mainwindow.h"
#include "logindialog.h"

QString keywordFormatColorString;
QString classFormatColorString;
QString singleLineCommentFormatColorString;
QString quotationFormatColorString;
QString functionFormatColorString;
QString showFieldFormatColorString;
QString htmlNumberFormatColorString;
QString dollarNumberFormatColorString;
QString stringFormatColorString;

QString deskTopColorString;
QString fairyCharFieldColorString;
QString fairyNumericFieldColorString;
QString fairyDateFieldColorString;
QString fairyLogicalFieldColorString;

QString fairyLocal;
QString historySize;

QSize toolIconSize;
bool toolButtonHide;
int editFontPlus;
QSize toolButtonSize;
QSize configButtonSize;
bool savePassword;
QStringList wordList;

QSize pushButtonIconSize;

MainWindow *mainWindow;

QString fairy_sql_host;
QString fairy_sql_user;
QString fairy_sql_passwd;
unsigned int fairy_sql_port;
QString fairy_sql_unix_socket;
QString company_directory;

int main(int argc, char *argv[])
{
    Q_INIT_RESOURCE(fairySQL);


    QApplication a(argc, argv);
    QCoreApplication::setOrganizationName("Hevele-Hegyi-Istvan");
    QCoreApplication::setOrganizationDomain("hevele.juniorcom.ro");
    QCoreApplication::setApplicationName("qtFairySQL-0.9.1-mysql");

    QSettings settings;

    savePassword = settings.value("logindialog/savepassword", true).toBool();

    fairy_sql_user = settings.value("logindialog/username", "").toString();
    if (savePassword)
        fairy_sql_passwd = settings.value("logindialog/password", "").toString();
    fairy_sql_host = settings.value("logindialog/host", "").toString();
    fairy_sql_unix_socket = settings.value("logindialog/socket", "").toString();
    QString portString = settings.value("logindialog/port", 0).toString();
    fairy_sql_port = portString.toInt();

    QLoginDialog *loginDialog = new QLoginDialog;

    bool ok = false;
    if (loginDialog->exec())
    {
        if (loginDialog->result() == QDialog::Accepted)
        {
            fairy_sql_user = loginDialog->getLoginUserName();
            fairy_sql_passwd = loginDialog->getLoginPassword();
            fairy_sql_host = loginDialog->getLoginHost();
            fairy_sql_unix_socket = loginDialog->getLoginSocket();
            QString portString = loginDialog->getLoginPort();
            fairy_sql_port = portString.toInt();
            ok = true;
        }
    }

    delete loginDialog;

    if (!ok)
        return -1;

    MainWindow w;
    w.show();

    return a.exec();
}
