/****************************************************************************
**
** Copyright (C) 2014 Hevele Hegyi Istvan.
**
** This file is part of the fairySQL project.
**
** Copyright (C) 2013 Digia Plc and/or its subsidiary(-ies).
** Contact: http://www.qt-project.org/legal
**
** $QT_BEGIN_LICENSE:BSD$
** You may use this file under the terms of the BSD license as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of Digia Plc and its Subsidiary(-ies) nor the names
**     of its contributors may be used to endorse or promote products derived
**     from this software without specific prior written permission.
**
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
**
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef __SQLMODEL_H
#define __SQLMODEL_H

#include <QSqlQueryModel>

#include "sqlglobals.h"

//QFairySqlModel

class QFairySqlModel : public QSqlQueryModel
{
    Q_OBJECT

public:
    QFairySqlModel(QObject *parent = 0,  QSqlDatabase db = QSqlDatabase());
    void addCharField(int i);
    void addNumericField(int i);
    void addDateField(int i);
    void addLogicalField(int i);
    void addTextField(int i);
    void addBlobField(int i);
    void addDoubleField(int i);
    void addEditableField(int i);
    void clearLists();

    QVariant data(const QModelIndex &item, int role) const;
    Qt::ItemFlags flags(const QModelIndex &index) const;
    bool setData(const QModelIndex &index, const QVariant &value, int role);
    void setFieldValue(int a_primaryIndexColumn,
                       const QString &a_tableName,
                       const QString &a_schemaName);

    QList<QFieldItem *> fieldList;

signals:
    void selectEditedRow(const QModelIndex&);

private:
    QList<int> charFields;
    QList<int> numericFields;
    QList<int> dateFields;
    QList<int> logicalFields;
    QList<int> textFields;
    QList<int> blobFields;
    QList<int> doubleFields;
    QList<int> editableFields;

    int primaryIndexColumn;
    QString tableName;
    QString schemaName;

    bool saveFieldValue(const QString &, int, const QString&);

};
#endif //__SQLMODEL_H
