/****************************************************************************
**
** Copyright (C) 2014 Hevele Hegyi Istvan.
**
** This file is part of the fairySQL project.
**
** Copyright (C) 2013 Digia Plc and/or its subsidiary(-ies).
** Contact: http://www.qt-project.org/legal
**
** $QT_BEGIN_LICENSE:BSD$
** You may use this file under the terms of the BSD license as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of Digia Plc and its Subsidiary(-ies) nor the names
**     of its contributors may be used to endorse or promote products derived
**     from this software without specific prior written permission.
**
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
**
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef __TABLEVIEW_H
#define __TABLEVIEW_H

#include <QTableView>

//QFairyTableView

class QFairyTableView : public QTableView
{
    Q_OBJECT
public:
    explicit QFairyTableView(QWidget *parent = 0);
    bool isReadOnly();
    void setReadOnly(bool);

signals:
    void enterSignal(QModelIndex);
    void noemptyEnterSignal();
    void insertSignal();
    void noemptyInsertSignal();
    void controlInsertSignal();
    void noemptyControlInsertSignal();
    void deleteSignal();
    void backspaceSignal();
    void f8Signal(const QString&);
    void f9Signal();
    void f3Signal();
    void showList(const QString&);
    void lcharSignal();
    void vcharSignal();
    void disableInsert(bool);

    void setModelQuery(const QString&, const QString&);

public slots:
    void setTableName(const QString &a_tableName);
    void setPrimaryKeyColumn(int, const QString&);

protected:
    virtual void contextMenuEvent(QContextMenuEvent *event);
    virtual void keyPressEvent(QKeyEvent *);

private slots:
    void insertRecord();
    void deleteRecord();
    void exportAsCSV();
    void listTheTable();

private:
    bool readOnly;
    bool modelIsEmpty;
    int primaryKeyColumn;
    QString tableName;
    QString primaryKeyColumnName;
};

#endif // __TABLEVIEW_H
