/****************************************************************************
**
** Copyright (C) 2014 Hevele Hegyi Istvan.
**
** This file is part of the fairySQL project.
**
** Copyright (C) 2013 Digia Plc and/or its subsidiary(-ies).
** Contact: http://www.qt-project.org/legal
**
** $QT_BEGIN_LICENSE:BSD$
** You may use this file under the terms of the BSD license as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of Digia Plc and its Subsidiary(-ies) nor the names
**     of its contributors may be used to endorse or promote products derived
**     from this software without specific prior written permission.
**
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
**
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef __TEXTVIEWER_H
#define __TEXTVIEWER_H

#include "widgets.h"
#include "textedit.h"

class QWebView;
class QWebPage;
class QToolButton;

//QFairyTextViewer

class QFairyTextViewer : public QFairyModalDialog
{
    Q_OBJECT

public:
    QFairyTextViewer(const QString &title, QWidget *parent = 0, const QString &fileName = "");

public slots:
    void setToolButtonIconSize(int);
    void reloadDocument();

signals:
    void cursorPositionChanged();

private slots:
    void filePrint();
    void filePrintPreview();
    void filePrintPdf();
    void filePrintOdf();
    void printPreview(QPrinter *);
    void setListFont();
    void fileDotPrint();
    void internet();


private:
    bool isHtml;
    QFairyTextEdit *textEdit;
    QWebView *webView;

    QString listFileName;

    void readSettings();
    void writeSettings();

    QToolButton *printButton;
    QToolButton *dotPrintButton;
    QToolButton *printPreviewButton;
    QToolButton *exportPdfButton;
    QToolButton *exportOdfButton;
    QToolButton *fontButton;

    QFont *fairyFont;

    void setFairyPrinterStatus(QPrinter *);
    void getFairyPrinterStatus(QPrinter *);

    qreal left,top,right,bottom;
    int ori,psize;
};
#endif //__TEXTVIEWER_H
