/****************************************************************************
**
** Copyright (C) 2014 Hevele Hegyi Istvan.
**
** This file is part of the fairySQL project.
**
** Copyright (C) 2013 Digia Plc and/or its subsidiary(-ies).
** Contact: http://www.qt-project.org/legal
**
** $QT_BEGIN_LICENSE:BSD$
** You may use this file under the terms of the BSD license as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of Digia Plc and its Subsidiary(-ies) nor the names
**     of its contributors may be used to endorse or promote products derived
**     from this software without specific prior written permission.
**
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
**
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef __WIDGETS_H
#define __WIDGETS_H

#include <QDialog>
#include <QToolButton>
#include <QTableView>
#include <QComboBox>
#include <QPushButton>

class QFairyLineEdit;

//QFairyModalDialog

class QFairyModalDialog : public QDialog
{
    Q_OBJECT

public:
    QFairyModalDialog(const QString &a_objectName, const QString &title, QWidget *parent = 0);
    ~QFairyModalDialog();

signals:
    void aboutToClose(const QString&);

signals:
    void endVerifyFairyInputLines();

public slots:
    void verifyFairyInputLines();

public:
    QList<QFairyLineEdit*> lineEditsToVerify;
    void insertLineEditToVerify(QFairyLineEdit*);
};

//QFairyLoginDialog

class QFairyLoginDialog : public QDialog
{
    Q_OBJECT

public:
    QFairyLoginDialog(const QString &title, QWidget *parent = 0);
    ~QFairyLoginDialog();

signals:
    void endVerifyFairyInputLines();

public slots:
    void verifyFairyInputLines();

public:
    QList<QFairyLineEdit*> lineEditsToVerify;
    void insertLineEditToVerify(QFairyLineEdit*);

};

//QFairyToolButton

class QFairyToolButton : public QToolButton
{
    Q_OBJECT

public:
    QFairyToolButton(QWidget *parent = 0);

    QSize sizeHint() const;

public slots:
    void setIconSize1(int);
};

//QFairyWaitDialog

class QFairyWaitDialog : public QDialog
{
    Q_OBJECT

public:
    QFairyWaitDialog(QWidget *parent = 0);
};

//QFairyComboBox

class QFairyComboBox : public QComboBox
{
    Q_OBJECT

public:
    QFairyComboBox(QWidget *parent = 0);

signals:
    void enterSignal();
    void insertSignal();
    void deleteSignal();
    void f3Signal();
    void backspaceSignal();

private:
    void keyPressEvent(QKeyEvent *);
};

//QFairyPushButton

class QFairyPushButton : public QPushButton
{
    Q_OBJECT

public:
    QFairyPushButton(const QIcon &, const QString & , QWidget *parent = 0);

    QSize sizeHint() const;
};

#endif //__WIDGETS_H
